// Viscosity of water at 20*c
var N_20_W = 1.002;
// Density water at 20*C (Rho)
var Density_20_Water = 0.998234;
var Rho_Water = Density_20_Water;
// Viscosity of water at 20C (Vis)
var Viscosity_20_Water = 0.01002;
// PI as defined in original sednterp
var PI = 3.1415926536;





function getModuleName()
{
    return "ExampleModule";
}
function getModuleVersion()
{
    return "20120215";
}
function getModuleInteractionXml()
{
    return "No Interactions";
}
function getModuleDate()
{
    return "2010/06/22";
}
function getModuleUI()
{
    return "qt_sednterp.ui";
}
function getModuleHTMLUI()
{
    return "./modules/QtScript/module1.html";
}
function _JustCallMe()
{
	console.log("Oh look I got called this is awesome function that does nothing");
	var obj = new Object();
	obj.NAME = "noname";
	obj.VALUE = 0;
	return obj;
}
function _RhoTKell(T)
{
    T       = parseFloat(T);

    var denom = 1 + 0.01687985 * T;
    var term1 = 999.83952 + 16.945176 * T;
    var term2 = (0.0079870401 * T) * T + 0.000046170461 * T * T * T;
    var term3 = 0.00000010556302 * T * T * T *
        T - (((2.8054253 * Math.pow(10, -10)) * T) * T * T * T * T);

    return 0.001000028 * (term1 - term2 + term3) / denom;
}

function _calculateDensityAtT(T, Density)
{
    Density = parseFloat(Density);

    return Density * _RhoTKell(T) / _RhoTKell(20);
}

function correctBufferDensityAtT_Heavy(density, temperature, D2O, D2O18, H2O18)
{

    density = parseFloat(density.VALUE);
    var T = parseFloat(temperature.VALUE);

    D2O       = parseFloat(D2O.VALUE);
    D2O18     = parseFloat(D2O18.VALUE);
    H2O18     = parseFloat(H2O18.VALUE);

    var delrho   = 0;
    var rhowater = _calculateDensityAtT(T, Density_20_Water);

    if (D2O > 0)
        delrho = delrho + D2O * (_CalcRhoD2OAtT(T) - rhowater);

    if (D2O18 > 0)
        delrho = delrho + D2O18 * (_CalcRhoD2O18AtT(T) - rhowater);

    if (H2O18 > 0)
        delrho = delrho + H2O18 * (_CalcRhoH2O18AtT(T) - rhowater);

    var obj = new Object();
    obj.NAME = "qtCorrectedDensity";
    obj.VALUE = density * rhowater / Density_20_Water + delrho;
    return obj;
}

function _CalcRhoD2OAtT(T)
{
    return 1.10602 * (1 - 1.0555 * Math.pow((T - 11.24), 2) *
                      (1.74224 + 482.502 / (T - 11.24 + 77.861)) * 0.000001);
}
function _CalcRhoD2O18AtT(T)
{
    return 1.21691 * (1 - 1.0555 * Math.pow((T - 11.46), 2) *
                      (1.74224 + 482.502 / (T - 11.46 + 77.861)) * 0.000001);
}
function _CalcRhoH2O18AtT(T)
{
    return 1.11255 * (1 - Math.pow((T - 4.305), 2) *
                      (1.74224 + 482.502 / (T - 4.305 + 77.861)) *
                      0.000001);
}







